local _random = {}
local t = {}
local pos = 0
local tictoc = false

local spawnMethods = {
    { type = "first" },
    { type = "last" },
    { type = "random" },
    { type = "cycle" },
    { type = "tictoc" },
    { type = "size_big" },
    { type = "size_small" }
}
spawnMethods[1].exec = (function() return 1 end) --first
spawnMethods[2].exec = (function() return #t end) --last
spawnMethods[3].exec = (function() return _random(1, #t) end) --random

-- cycle
spawnMethods[4].exec = (function()
    pos = pos + 1
    if pos > #t then pos = 1 end
    return pos
end)

-- tictoc (alternate first/last)
spawnMethods[5].exec = (function()
    tictoc = not tictoc
    if tictoc then return 1 else return #t end
end)

-- size_big (spawn around largest radius points first)
-- a lot can be done to improve speed here
-- as is, it can be very slow on large point sets
spawnMethods[6].exec = (function()
    local size = 0
    local idx = 1
    for key, value in pairs(t) do
        if value.r > size then
            size = value.r
            idx = key
        end
    end
    return idx
end)

-- size_small opposite of size_big (with same need for improvement)
spawnMethods[7].exec = (function()
    local size = 1000
    local idx = 1
    for key, value in pairs(t) do
        if value.r < size then
            size = value.r
            idx = key
        end
    end
    return idx
end)

local mt = {}
mt.__call = function(self, table, random)
    t = table;
    _random = random
    return self
end

setmetatable(spawnMethods, mt)

return spawnMethods
